﻿#version 300 es
/////////////////////////////////////////////////////////
// spokoinbli


#ifdef GL_FRAGMENT_PRECISION_HIGH
#define highmedp highp
#else
#define highmedp mediump
#endif

precision lowp float;

in mediump vec2 vTex;
out lowp vec4 outColor;
uniform lowp sampler2D samplerFront;

uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump float seconds;
uniform mediump float timeScale;
uniform vec3 colorOne;
uniform vec3 colorTwo;
uniform float countLine;



void main( void ) {
 vec2 uv = (vTex-srcOriginStart) / (srcOriginEnd - srcOriginStart);

	vec2 posT = uv - fract((seconds*timeScale)*0.5);
 vec2 posNorm = posT*countLine;
	vec2 moded = mod(posNorm, 4.0);

 float ar = abs(uv.y - 0.5) * 3.0;	
	float n = mod(moded.x + ar, 2.)-1.0;
	n = smoothstep(0.0,0.1,n);

	vec3 colors = mix(vec3(colorOne),vec3(colorTwo),n);

	lowp float a = texture(samplerFront, vTex).a;

	outColor = texture(samplerFront, vTex) + vec4( vec3(colors)*a, 0.0 );
}

