
/////////////////////////////////////////////////////////
// spokoinbli
%%FRAGMENTINPUT_STRUCT%%
/* input struct contains the following fields:
fragUV : vec2<f32>
fragPos : vec4<f32>
fn c3_getBackUV(fragPos : vec2<f32>, texBack : texture_2d<f32>) -> vec2<f32>
fn c3_getDepthUV(fragPos : vec2<f32>, texDepth : texture_depth_2d) -> vec2<f32>
*/
%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

/*
%%SAMPLERBACK_BINDING%% var samplerBack : sampler;
%%TEXTUREBACK_BINDING%% var textureBack : texture_2d<f32>; */


struct ShaderParams {

 timeScale : f32,
 colorOne : vec3<f32>,
 colorTwo : vec3<f32>,
 countLine : f32


};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;
/* gets replaced with:

struct ShaderParams {

	floatParam : f32,
	colorParam : vec3<f32>,
	// etc.

};

%//%SHADERPARAMS_BINDING%//% var<uniform> shaderParams : ShaderParams;
*/

%%C3PARAMS_STRUCT%%





@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
 var uv : vec2<f32> = (input.fragUV - c3Params.srcOriginStart) / (c3Params.srcOriginEnd - c3Params.srcOriginStart);

	var posT : vec2<f32> = uv - fract((c3Params.seconds*shaderParams.timeScale)*0.5);
 var posNorm : vec2<f32> = posT*shaderParams.countLine;
	var moded : vec2<f32> = posNorm - 4.0 * floor(posNorm/4.0);


 var ar : f32 = abs(uv.y - 0.5) * 3.0;	
	var n : f32 = ((moded.x + ar)- 2.0*floor((moded.x + ar)/2.0))-1.0;
	n = smoothstep(0.0,0.1,n);

	var colors : vec3<f32>  = mix(vec3<f32>(shaderParams.colorOne),vec3<f32>(shaderParams.colorTwo),n);

	var a : f32 = textureSample(textureFront, samplerFront, input.fragUV).a;

 var output : FragmentOutput;
 output.color = textureSample(textureFront, samplerFront, input.fragUV) + vec4<f32>(vec3<f32>(colors)*a, 0.0 );  
 return output; 

}



